$! make.com for xmaddressbook under OpenVMS
$!
$! You will need the Xvmsutils-lib to build and link. At least version 2.0
$! is requiered. You may get the package from 
$! http://www.decus.de:8080/www/vms/sw/xvmsutils.htmlx
$! 
$! Also MMS or MMK are requiered to use the descrip.mms. 
$! MMS you may buy from hp, MMK is available from
$! http://www.decus.de:8080/www/vms/sw/mmk.htmlx
$! If you have problems with the build you may contact me at 
$! zinser@decus.de (preferred) or zinser@sysdev.deutsche-boerse.com (work). 
$!
$ on error then goto err_exit
$!
$ Make   = ""
$ true   = 1
$ false  = 0
$ tmpnam = "temp_" + f$getjpi("","pid")
$ tc     = tmpnam + ".c"
$ cc_def = ""
$!
$! Look for MMS/MMK
$!
$ If F$Search ("Sys$System:MMS.EXE") .nes. "" Then Make = "MMS"
$ If F$Type (MMK) .eqs. "STRING" Then Make = "MMK"
$ if make .eqs. "" then goto make_err 
$!
$! Look for the compiler used
$!
$ if f$getsyi("HW_MODEL").ge.1024
$ then
$  comp  = "__decc__=1"
$  if f$trnlnm("SYS").eqs."" then define sys sys$library:
$ else
$  if f$search("SYS$SYSTEM:DECC$COMPILER.EXE").eqs.""
$   then
$    comp  = "__vaxc__=1"
$    if f$trnlnm("SYS").eqs."" then define sys sys$library:
$   else
$    if f$trnlnm("SYS").eqs."" then define sys decc$library_include:
$    comp  = "__decc__=1"
$  endif
$ endif
$ if f$search("x11vms:vmsutil.h") .eqs. "" then goto x11vms_err
$!
$!      Build the option-file
$!
$ open/write optf xmaddressbook.opt
$ write optf "Identification=""Xmaddress 1.5.3"""
$ if f$trnlnm("x11vmsshr") .eqs. "" 
$ then
$   write optf "x11vms:xvmsutils.olb/lib"
$ else
$   write optf "x11vmsshr/share"
$ endif
$!
$!
$!  Find out which X-Version we're running.  This will fail for older
$!  VMS versions (i.e., v5.5-1).  Therefore, choose DECWindows XUI for
$!  default.
$!
$ On Error Then GoTo XUI
$ @sys$update:decw$get_image_version sys$share:decw$xlibshr.exe decw$version
$ if f$extract(4,3,decw$version).eqs."1.0"
$ then
$   write optf "Sys$share:DECW$DWTLIBSHR.EXE/Share"
$ endif
$ if f$extract(4,3,decw$version).eqs."1.1"
$ then
$   write optf "sys$share:decw$xmlibshr.exe/share"
$   write optf "sys$share:decw$xtshr.exe/share"
$ endif
$ if f$extract(4,3,decw$version).eqs."1.2"
$ then
$   write optf "sys$share:decw$xmlibshr12.exe/share"
$   write optf "sys$share:decw$xtlibshrr5.exe/share"
$ endif
$ GoTo MAIN
$!
$XUI:
$!
$   write optf "Sys$share:DECW$DWTLIBSHR.EXE/Share"
$MAIN:
$!
$ on error then goto err_exit
$ write optf "sys$share:decw$xlibshr.exe/share"
$ close optf
$!
$! Build the thing
$!
$ gosub check_function
$ cc_def = cc_def - ","
$ write sys$output "Compiling Xmaddressbook sources ..."
$   'make'/macro=('comp',cdefs='cc_def')
$ write sys$output "Xmaddressbook build completed"
$ exit
$MAKE_ERR:
$ write sys$output "MMS or MMK must be installed"
$ goto err_exit
$X11VMS_ERR:
$ write sys$output "X11VMS library must be installed"
$ goto err_exit
$ERR_EXIT:
$ close/nolog optf
$ write sys$output "Exiting..."
$ exit 2
$!
$!------------------------------------------------------------------------------
$!
$! Check if a specific function needs to be implemented
$!
$CHECK_FUNCTION:
$!
$! x11vms_getpwuid - horrible hack to get around missing functionality in
$!                   the C RTLs implementation
$!
$ func  = "x11vms_getpwuid"
$ hfile = ""
$ fdef  = "GETPWUID_HACK"
$ open/write tmpc 'tc
$ write tmpc "#include <pwd.h>"
$ write tmpc "#include <stdio.h>"
$ write tmpc "#include <unistd.h>"
$ write tmpc "int main(){"
$ write tmpc "  struct passwd *PasswdRec;"
$ write tmpc "  PasswdRec = getpwuid(getuid());"
$ write tmpc "  printf(""%s\n"",PasswdRec->pw_gecos);"
$ write tmpc "}"
$ close tmpc
$ gosub cc_prop_check
$ return
$!
$!------------------------------------------------------------------------------
$!
$! Check for properties of C/C++ compiler
$!
$CC_PROP_CHECK:
$ cc_prop = false
$ set message/nofac/noident/nosever/notext
$ on error then continue
$ cc 'all_cflags' 'tmpnam'
$ if $status then cc_prop = true
$ set message/fac/ident/sever/text
$ delete/nolog 'tmpnam'.*;*
$ if cc_prop 
$ then
$   if (func .nes. "") 
$   then
$     write sys$output "Function ''func' implemented in C RTL"
$   else
$     write sys$output "h-file ''hfile' part of C RTL"
$   endif
$ else 
$   cc_def = cc_def + "," + fdef
$ return
$!------------------------------------------------------------------------------
